#/bin/bash
#Run this on rootdirectory of package

#Change these:
maintainer="Aapo Rantalainen <aapo.rantalainen@gmail.com>"
address="ppa:aapo-rantalainen/games"
minor_version=-2

#This is added to changelog, could be empty
additional_message=""

#Target releases
#release_list=( hardy jaunty karmic lucid )

#release_list=( maverick )
#release_list=( karmic )
#release_list=( lucid )
#release_list=( natty )
#release_list=( oneiric )
release_list=( precise )
date="`date -R`"


cd debian
mv changelog changelog_original

#check first line of changelog
temp=( `head changelog_original -n1` )

#package name is first word in changleog
package=${temp[0]}

#second word is version number but it has parenthesis ()
ver_tmp=${temp[1]}

#remove first and last character
version=${ver_tmp:1:${#ver_tmp}-2}

message="  * "

cd ..

for release in "${release_list[@]}"
do

cd debian

echo $package \("$version""$minor_version"+"$release"\) $release\; urgency=low >changelog
echo '' >>changelog
echo "$message" "$additional_message" >>changelog
echo '' >>changelog
echo ' -- '"$maintainer"'  '"$date"  >>changelog
echo '' >>changelog
cat changelog_original >> changelog

cd ..
debuild -S -sa

cd ..
dput -f "$address" "$package"_"$version""$minor_version"+"$release"_source.changes
cd -

#backup used changelogs, this helps debugging
cd debian
mv changelog changelog_"$release"
cd ..
done

#copy changelog back, so this script can be runned second time too
cd debian
mv changelog_original changelog

